<template>
  <div class="files-dropdown">
    <ObMenuDropdown
      v-if="filesCount"
      :remote-opt="getFilesName"
      parent-container-selector=".order-card-body"
      @click.native.stop.prevent="() => {}"
      data-stop-propagation
    >
      <div
        class="dropdown-button"
        slot="button"
      >
        <i class="icon attach" />
        <span>{{ filesCount }}</span>
      </div>
    </ObMenuDropdown>
  </div>
</template>

<script>
import api from '@/api'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'

export default {
  name: 'OrderFilesDropdown',
  props: {
    fileUuids: {
      type: Array,
      default: () => []
    }
  },
  components: {
    ObMenuDropdown
  },
  computed: {
    filesCount () {
      return this.fileUuids ? this.fileUuids.length : 0
    }
  },
  methods: {
    async getFilesName () {
      try {
        const names = await api.files.getFilesName({ uuids: this.fileUuids })
        return [
          ...names.map(({ fileUuid, fileName }) => {
            return {
              uuid: fileUuid,
              title: fileName,
              icon: 'attach',
              method: () => this.downloadFile(fileUuid)
            }
          }),
          {
            uuid: 'all',
            title: 'Скачать все файлы',
            icon: 'download',
            isHidden: names.length < 2,
            method: () => this.downloadAllFiles()
          }
        ]
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных`
        })
      }
    },
    async downloadFile (uuid, isNotification) {
      try {
        await api.files.getFile(uuid, true)
        if (isNotification) {
          this.$notification({
            type: 'system_notification_success',
            message: `Файл успешно загружен`
          })
        }
      } catch (e) {
        if (isNotification) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка загрузки файла`
          })
        }
      }
    },
    async downloadAllFiles () {
      const notificationId = `${new Date().getTime()}save`

      this.$notification({
        type: 'system_notification_in_load',
        message: `Загрузка файлов`,
        id: notificationId
      })

      try {
        await Promise.all(this.fileUuids.map(uuid => this.downloadFile(uuid, false)))

        this.$notification({
          type: 'system_notification_success',
          message: `Файлы успешо загружены`,
          id: notificationId
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки файлов`,
          id: notificationId
        })
      } finally {
        this.$notification({event: 'close', id: notificationId})
      }
    },
  }
}
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";

.files-dropdown {
  .dropdown-button {
    position: absolute;
    z-index: 3;
    display: flex;
    align-items: center;
    i {
      position: relative!important;
      font-size: 12px!important;
    }
    span {
      margin-left: 3px;
      @include font-mixin(12px, 16px, 400, $color-text-base, 0.2px);
    }
  }
}
</style>